# Copyright 2020 StrongDM Inc
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
import grpc

from . import account_attachments_pb2 as account__attachments__pb2


class AccountAttachmentsStub(object):
  """AccountAttachments assign an account to a role.
  """

  def __init__(self, channel):
    """Constructor.

    Args:
      channel: A grpc.Channel.
    """
    self.Create = channel.unary_unary(
        '/v1.AccountAttachments/Create',
        request_serializer=account__attachments__pb2.AccountAttachmentCreateRequest.SerializeToString,
        response_deserializer=account__attachments__pb2.AccountAttachmentCreateResponse.FromString,
        )
    self.Get = channel.unary_unary(
        '/v1.AccountAttachments/Get',
        request_serializer=account__attachments__pb2.AccountAttachmentGetRequest.SerializeToString,
        response_deserializer=account__attachments__pb2.AccountAttachmentGetResponse.FromString,
        )
    self.Delete = channel.unary_unary(
        '/v1.AccountAttachments/Delete',
        request_serializer=account__attachments__pb2.AccountAttachmentDeleteRequest.SerializeToString,
        response_deserializer=account__attachments__pb2.AccountAttachmentDeleteResponse.FromString,
        )
    self.List = channel.unary_unary(
        '/v1.AccountAttachments/List',
        request_serializer=account__attachments__pb2.AccountAttachmentListRequest.SerializeToString,
        response_deserializer=account__attachments__pb2.AccountAttachmentListResponse.FromString,
        )


class AccountAttachmentsServicer(object):
  """AccountAttachments assign an account to a role.
  """

  def Create(self, request, context):
    """Create registers a new AccountAttachment.
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def Get(self, request, context):
    """Get reads one AccountAttachment by ID.
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def Delete(self, request, context):
    """Delete removes a AccountAttachment by ID.
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def List(self, request, context):
    """List gets a list of AccountAttachments matching a given set of criteria.
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')


def add_AccountAttachmentsServicer_to_server(servicer, server):
  rpc_method_handlers = {
      'Create': grpc.unary_unary_rpc_method_handler(
          servicer.Create,
          request_deserializer=account__attachments__pb2.AccountAttachmentCreateRequest.FromString,
          response_serializer=account__attachments__pb2.AccountAttachmentCreateResponse.SerializeToString,
      ),
      'Get': grpc.unary_unary_rpc_method_handler(
          servicer.Get,
          request_deserializer=account__attachments__pb2.AccountAttachmentGetRequest.FromString,
          response_serializer=account__attachments__pb2.AccountAttachmentGetResponse.SerializeToString,
      ),
      'Delete': grpc.unary_unary_rpc_method_handler(
          servicer.Delete,
          request_deserializer=account__attachments__pb2.AccountAttachmentDeleteRequest.FromString,
          response_serializer=account__attachments__pb2.AccountAttachmentDeleteResponse.SerializeToString,
      ),
      'List': grpc.unary_unary_rpc_method_handler(
          servicer.List,
          request_deserializer=account__attachments__pb2.AccountAttachmentListRequest.FromString,
          response_serializer=account__attachments__pb2.AccountAttachmentListResponse.SerializeToString,
      ),
  }
  generic_handler = grpc.method_handlers_generic_handler(
      'v1.AccountAttachments', rpc_method_handlers)
  server.add_generic_rpc_handlers((generic_handler,))
